#ifndef _KEY_REMIX_H_
#define _KEY_REMIX_H_

#define KEY_REMIX_LIMIT  5

#define REMIX_TYPE_NONE   0
#define REMIX_TYPE_REMAP  1
#define REMIX_TYPE_CHEAT  2
#define REMIX_TYPE_HOLD   3
#define REMIX_TYPE_COUNT  4

#define KEYREMIX_OUTPUT_DIR "keymaps"

#include "arm11/drivers/hid.h"
#define DEFAULT_CHEATKEY (KEY_DDOWN|KEY_L|KEY_R|KEY_SELECT)

#include <stdint.h>

typedef uint8_t remix_t;
typedef uint32_t phykey_t;
typedef uint16_t conkey_t;

typedef struct{
    remix_t     remix_type;
    phykey_t    device_keys;
    conkey_t    game_keys;
} key_remix_t;

extern key_remix_t g_keyremixConfig[KEY_REMIX_LIMIT];

uint16_t keyremix_cheatkey();
void keyremix_freeze();
void keyremix_update( uint16_t active_cheatkey );
const char* keyremix_dump( const char* gbafile );
const char* keyremix_load( const char* gbafile );

#endif//_KEY_REMIX_H_
