#ifndef __OAF_PAGES_H__
#define __OAF_PAGES_H__

#include "arm11/atp.h"
#include "arm11/cheat.h"
#include "arm11/keyremix.h"
#include "arm11/open_agb_firm.h"

extern atp_error_t disp_str( atp_callerdata_t , atp_counter_t, atp_linecfg_t * );
extern atp_error_t use_config_page( struct global_oaf_config* );
extern atp_error_t use_cheat_page( const char* );
extern atp_error_t use_keyremix_page( char *file );

extern atp_error_t help_page( atp_text_t *wording, atp_counter_t length );

#define use_help_page(text) help_page((text), sizeof((text))/sizeof(atp_text_t))
#define WAIT_ON_ACT( act ) ( ATP_POWER_OFF == (act) ) ? ATP_POWER_OFF : ATP_PAGE_REFRESH
#define WAIT_ON_ERRPAGE( page ) WAIT_ON_ACT( atp_show(1, (page), NULL) )

#define DECLARE_ERROR_PAGE(name, message) 	static atp_error_t name (atp_callerdata_t, atp_counter_t, atp_linecfg_t *c) \
											{ \
												c->text = message; \
												c->text_align = ATP_PLACEMENT_CENTER; \
												c->text_color = ATP_COLOR_RED; \
												return ATP_SUCCESS; \
											}


#endif//__OAF_PAGES_H__